<html>
<!-- Gable was here -->

<head>
	<title>regexle</title>
	<meta name="description"
		content="It's a daily hexagonal crossword puzzle where you need to fill in the hexagons with character sequences, so that they match the regular expressions (\"
		RegEx\") listed around the edges." />
	<!-- <meta http-equiv="refresh" content="5"> -->
	<script src="./script.js"></script>
	<link rel="stylesheet" type="text/css" href="./style.css" />
	<link rel="apple-touch-icon" sizes="180x180" href="/icons/apple-touch-icon.png" />
	<link rel="icon" type="image/png" sizes="32x32" href="/icons/favicon-32x32.png" />
	<link rel="icon" type="image/png" sizes="16x16" href="/icons/favicon-16x16.png" />
	<link rel="manifest" href="/icons/site.webmanifest" />
	<link rel="mask-icon" href="/icons/safari-pinned-tab.svg" color="#7f7f7f" />
	<link rel="shortcut icon" href="/icons/favicon.ico" />
	<meta name="apple-mobile-web-app-title" content="Regexle" />
	<meta name="application-name" content="Regexle" />
	<meta name="msapplication-TileColor" content="#7f7f7f" />
	<meta name="msapplication-config" content="/icons/browserconfig.xml" />
</head>

<body>
	<!-- Sneaky sneaky! -->
	<script>
		/* workaround for ff bug 1404468 */
	</script>

	<div class="page">
		<div class="page_header">

			<div class="page_header_title">regexle</div>
			<div class="page_header_box" id="info_toggle_box">
				<input type="checkbox" id="info_toggle_checkbox" hidden>
				<img src="icons/info.svg" class="page_header_box_button" width="75%" id="info_toggle_image"
					onclick="toggleInfo()" alt="Info Window Button" />
			</div>
			<div class="page_header_box" id="hint_toggle_box">
				<input type="checkbox" id="hint_toggle_checkbox" hidden>
				<img src="icons/hint.svg" class="page_header_box_button" width="100%" id="hint_toggle_image"
					onclick="toggleHintMode()" alt="Hint Mode Button">
				<div class="live_hint_counter" id="live_hint_counter" align="center"></div>
			</div>
			<div class="page_header_box" id="settings_toggle_box">
				<input type="checkbox" id="completion_toggle_checkbox" hidden>
				<img src="icons/close.svg" class="page_header_box_button" width="75%" id="completion_toggle_image"
					hidden onclick="toggleCompletion()" alt="Close Window Button">

				<input type="checkbox" id="settings_toggle_checkbox" hidden>
				<img src="icons/gear.svg" class="page_header_box_button" width="100%" id="settings_toggle_image"
					onclick="toggleSettings()" alt="Settings Window Button" />
			</div>
		</div>
		<div class="page_canvas">
			<div class="board" align="center">
				<div class="board_center"></div>
			</div>
		</div>

		<div class="page_footer" id="puzzle_credit">Loading puzzle...</div>

		<div id="settings_overlay">
			<div id="settings_overlay_box">
				<div class="settings_element_center">settings</div>
				<hr />

				<div class="settings_element">
					<div class="settings_element_left">
						<div class="settings_element_title">Reset Board</div>
						<div class="settings_element_description">This will only reset the current game day & size</div>
					</div>
					<div class="settings_element_right">
						<button class="settings_element_button" id="reset">Reset</button>
					</div>
				</div>

				<div class="settings_element">
					<div class="settings_element_left">
						<div class="settings_element_title">Reset All Game Data</div>
						<div class="settings_element_description">This will remove all game data including game saves
							and config</div>
					</div>
					<div class="settings_element_right">
						<button class="settings_element_button" id="reset_all">Reset All</button>
					</div>
				</div>

				<div class="settings_element" id="nolocalstorage">
					<div class="settings_element_left">
						<div class="settings_element_title">
							Local Storage
						</div>
						<div class="settings_element_description">
							<div>regexle is currently unable to store puzzle solutions or config to the device.</div>
						</div>
					</div>
					<div class="settings_element_right">Disabled</div>
				</div>
				<div class="settings_element" id="localstorage">
					<div class="settings_element_left">
						<div class="settings_element_title">
							Local Storage
						</div>
						<div class="settings_element_description">
							UUID:&nbsp;<span class="uuid"></span>
						</div>
					</div>
					<div class="settings_element_right">Enabled</div>
				</div>
				<hr />

				<div class="settings_element">
					<div class="settings_element_left">
						<div class="settings_element_title">High Contrast Mode</div>
						<div class="settings_element_description">This will adjust the coloring and sizing of correct
							and incorrect regex expressions</div>
					</div>
					<div class="settings_element_right">
						<label class="settings_switch">
							<input type="checkbox" id="colorblind_toggle">
							<span class="settings_slider"></span>
						</label>
					</div>
				</div>
				<hr />

				<form>
					<div class="settings_element">
						<div class="settings_element_left">
							<div class="settings_element_title">Puzzle Size</div>
							<div class="settings_element_description">This is the length of characters of the side of
								the hexagon</div>
						</div>
						<div class="settings_element_right">
							<input enterkeyhint="go" class="settings_number_input" type="number" placeholder="3" min="1"
								max="32" id="input_side" name="side" autocomplete="off" />
						</div>
					</div>
					<div class="settings_element">
						<div class="settings_element_left">
							<div class="settings_element_title">Puzzle Day</div>
							<div class="settings_element_description">This is the day selector for the puzzle</div>
						</div>
						<div class="settings_element_right">
							<input enterkeyhint="go" class="settings_number_input" type="number" placeholder="1"
								id="input_day" name="day" autocomplete="off" />
						</div>
					</div>
					<div class="settings_element">
						<div class="settings_element_left"></div>
						<div class="settings_element_right">
							<input type="submit" class="settings_element_button" id="submit" value="Submit" />
						</div>
					</div>
				</form>
				<hr />

				<div class="settings_element">
					<div class="settings_element_left">
						<div class="settings_element_title">
							<span id="puzzle_credit"></span>
						</div>
					</div>
					<div class="settings_element_right">
						Time remaining:&nbsp;<div class="countdown"></div>
					</div>
				</div>
				<hr />

				<div class="settings_element">
					<div class="settings_element_left">
						<div class="settings_element_title">Authors:</div>
					</div>
					<div class="settings_element_right" align="right">
						<a href="https://nathaniel.bell.es">Nathaniel Belles</a>&emsp;&&emsp;
						<a href="https://gablebrown.com/">Gable Brown</a>
					</div>
				</div>
				<div class="settings_element">
					<div class="settings_element_left">
						<div class="settings_element_title">Inspired by:</div>
					</div>
					<div class="settings_element_right">
						<a href="https://github.com/Jimbly/regex-crossword"> Jimbly</a>
					</div>
				</div>
				<hr />

				<div class="settings_element">
					<div class="settings_element_left">
						<div class="settings_element_title">Having an issue?</div>
					</div>
					<div class="settings_element_right">
						<a href="https://gitlab.com/Nathaniel.Belles/regexle/-/issues">Feedback</a>
					</div>
				</div>

			</div>
		</div>

		<div id="info_overlay">
			<div id="info_overlay_box">
				<div class="info_element_center">regexle</div>
				<hr />

				<div class="info_element_left">
					<div class="info_element_title">What is it?</div>
					<div class="info_element_description">
						It's a daily hexagonal crossword puzzle where you need to fill in the hexagons
						with alphanumeric character sequences, so that they match the regular expressions
						("RegEx") rules listed around the edges. Note that the rule must be a full match,
						and empty hexagons are treated as spaces.
					</div>
				</div>
				<hr />

				<div class="info_element_left">
					<div class="info_element_title">How does it work?</div>
					<div class="info_element_description">
						Each rule will turn <span class="match"><span class="mode_colorblind">bold purple</span><span
								class="mode_colornormal">bold green</span></span> when the regex is satisfied, and
						<span class="nomatch"><span class="mode_colorblind">orange</span><span
								class="mode_colornormal">red</span></span> when the regex is not satisfied. When a cell
						is selected,
						the corresponding rules along each axis will be <span class="highlighted">underlined</span>.
					</div>
				</div>
				<hr />

				<div class="info_element_left">
					<div class="info_element_title">Traversing the puzzle</div>
					<div class="info_element_description">
						To traverse the puzzle, Tab and Shift-Tab can be used to progress and retreat
						respectively. By default, the puzzle will traverse from left to right and top
						to bottom. By clicking on a rule, the puzzle traversal order is updated to only
						traverse along the axis of the selected rule.
					</div>
				</div>
				<hr />

				<div class="info_element_left">
					<div class="info_element_title">Hint Mode</div>
					<div class="info_element_description">
						If hints are needed click on the lightbulb. In hint mode, any filled cells that
						match the desired solution will be highlighted green <span><svg
								style="position: absolute; width: 1.5rem; transform: translate(-15%, -15%);"
								viewBox="0 0 3000 3000" xmlns="http://www.w3.org/2000/svg"
								alt="Example hexagon correct">
								<path fill="rgb(97, 139, 85)" stroke="#7f7f7f" stroke-width="100"
									d="M 1500 500 L 633.974609 1000 L 633.974609 2000 L 1500 2500 L 2366.025391 2000 L 2366.025391 1000 Z" />
							</svg><span style="visibility: hidden">__</span> and incorrect cells will be
							highlighted yellow <span><svg
									style="position: absolute; width: 1.5rem; transform: translate(-15%, -15%);"
									viewBox="0 0 3000 3000" xmlns="http://www.w3.org/2000/svg"
									alt="Example hexagon incorrect">
									<path fill="rgb(178, 159, 76)" stroke="#7f7f7f" stroke-width="100"
										d="M 1500 500 L 633.974609 1000 L 633.974609 2000 L 1500 2500 L 2366.025391 2000 L 2366.025391 1000 Z" />
								</svg>
								<span style="visibility: hidden">__</span></span>. The puzzle will keep track of
							which cells were used for hints
							and how many hints were used.
					</div>
				</div>
				<hr />

				<div class="info_element_left">
					<div class="info_element_title">Need more help?</div>
					<div class="info_element_description">
						<a href="https://regex101.com">regex101.com</a> can be a great resource for learning
						regex. It has a quick reference to see what each token means, as well as a place to test
						regex against example strings.
					</div>
				</div>
				<hr />

				<div class="info_element_center">
					<button class="info_element_button" onclick="toggleInfo()"
						style="font-size: 1.25rem; border-radius: 0.75rem; width: fit-content;">Let's play!</button>
				</div>
			</div>
		</div>

		<div id="completion_overlay">
			<div id="completion_overlay_box">
				<div class="completion_element_center">Completed!</div>
				<div class="completion_element_center">
					<div style="background-color: rgb(230, 230, 230); border-radius: 1rem;">
						<div class="completion_element_center" id="puzzle_day" align="center"
							style="font-size: 1.25rem;"></div>
						<div class="completion_element_center" id="completion_time" align="center"
							style="font-size: 1.25rem;"></div>
						<div class="completion_element_center" id="hint_count" align="center"
							style="font-size: 1.25rem;"></div>
						<div class="completion_element_center" id="share_string" align="center"
							style="font-size: 1.25rem; line-height: 1.2;"></div>
					</div>
					<span style="font-size: 0.5rem;">&nbsp;</span>
					<div>
						<div style="background-color: rgb(230, 230, 230); border-radius: 1rem; margin: 0.5rem;">
							<div align="center" style="font-size: 1.25rem; text-decoration: underline;">Global Stats for
								x<span class="stats_side"></span>
							</div>
							<div class="completion_element_center" align="center" style="font-size: 1.25rem;">
								Top&nbsp;<span id="percentile">---</span>% of regexlers</div>
							<div class="completion_element_center" align="center"
								style="font-size: 1.25rem; line-height: 1.2;"><span
									id="player_count">---</span>&nbsp;regexler
							</div>
						</div>
						<div style="background-color: rgb(230, 230, 230); border-radius: 1rem; margin: 1rem;">
							<div align="center" style="font-size: 1.25rem; text-decoration: underline;">Personal Stats
								for x<span class="stats_side"></span>
							</div>
							<div class="completion_element_center" align="center"
								style="font-size: 1.25rem; line-height: 1.2;">
								Fastest&nbsp;solve:&nbsp;<span id="stats_solve_fastest">---</span>
							</div>
							<div class="completion_element_center" align="center" style="font-size: 1.25rem;">
								Average&nbsp;time:&nbsp;<span class="stats_average">---</span>
							</div>
							<div class="completion_element_center" align="center" style="font-size: 1.25rem;">
								Total&nbsp;solves:&nbsp;<span id="stats_solve_count">---</span>
							</div>
							<div class="completion_element_center" align="center" style="font-size: 1.25rem;">
								Daily&nbsp;streak:&nbsp;<span class="stats_streak">---</span>
							</div>
						</div>
					</div>
				</div>
				<div class="completion_element_center" style="font-size: 2rem;">
					<button id="share_results" class="completion_element_button" onclick="copyResults()"
						style="font-size: 1.25rem; border-radius: 0.75rem; width: fit-content;">Share Results!</button>
					&nbsp; <button id="permalink" class="completion_element_button" onclick="copyPermalink()"
						style="font-size: 1.25rem; border-radius: 0.75rem; width: fit-content;">&#x1F517;</button>
					&nbsp; <button class="completion_element_button" onclick="goToRandomPuzzle()"
						style="font-size: 1.25rem; border-radius: 0.75rem; width: fit-content;">&#x1F3B2;</button>
				</div>
				<div class="settings_element_center" style="font-size: 1.25rem;">
					Time to next puzzle:&nbsp;<div class="countdown">soon&trade;</div>
				</div>
				<div class="completion_element_center">
					<img id="completion_image" style="max-width: 70%; max-height: 20vh; border-radius: 1rem;"
						alt="Completion Celebration Image">
				</div>

			</div>
		</div>
	</div>
</body>

</html>